package com.goafanti.common.dao;

import com.goafanti.common.bo.ErrorDunListBo;
import com.goafanti.common.model.TOrderMid;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * 订单中间表(TOrderMid)表数据库访问层
 *
 * @author makejava
 * @since 2024-11-15 09:04:09
 */
public interface TOrderMidMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    TOrderMid queryById(Integer id);


    /**
     * 查询指定行数据
     *
     * @param tOrderMid 查询条件
     * @param pageable  分页对象
     * @return 对象列表
     */
    List<TOrderMid> findTOrderMidList(TOrderMid tOrderMid, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param tOrderMid 查询条件
     * @return 总行数
     */
    int findTOrderMidCount(TOrderMid tOrderMid);

    /**
     * 新增数据
     *
     * @param tOrderMid 实例对象
     * @return 影响行数
     */
    int insert(TOrderMid tOrderMid);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<TOrderMid> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<TOrderMid> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<TOrderMid> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<TOrderMid> entities);

    /**
     * 修改数据
     *
     * @param tOrderMid 实例对象
     * @return 影响行数
     */
    int update(TOrderMid tOrderMid);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);


    TOrderMid selectByOrderNo(String orderNo);

    void updateSalesmanId(@Param("aid")String aid, @Param("transferId")String transferId);

    void updateFinanceId(@Param("id")String id, @Param("financeId")String financeId);

    void updatefinalReceivables(@Param("orderNo")String orderNo, @Param("amount") BigDecimal amount,
                                @Param("count") BigDecimal count, @Param("receivablesTime") Date receivablesTime);

    void updateInvoice(String orderNo);


    String selectDepNameByDepid(String orderDep);

    void updateCostAmount(String orderNo);



    int updateByOrderNo(TOrderMid tm);

    void updateByList(List<String> addList2);

    List<ErrorDunListBo> selectErrorDun();

    void updateErrorDun();

    int judgeProjectType(String orderNo);


    List<TOrderMid> selectAll();

    void updateStopProjectByOrderNo(String orderNo);

    void updateBidTypeByOrderNo(String orderNo);


    void insertSelective(TOrderMid tm);

    void updateMid(String orderNo);

    void updateOExpense(String orderNo);
}

